︠59cd739e-4e80-417d-8561-c4883e7dcb5es︠
print ("Homework 16 (2) 10.2 #2 : Use Kruskal's algorithm to find a minimal spanning tree for the capital cities of New England...")
print("")
print("ME: Augusta, Maine") # vertex 1
print("MA: Boston, Massachusetts") # vertex 2
print("NH: Concord, New Hampshire") # vertex 3
print("CT: Hartford, Connecticut") # vertex 4
print("VT: Montpelier, Vermont") # vertex 5
print("RI: Providence, Rhode Island") # vertex 6
print("")

print ("While not geographically true, the graph below does accurately depict the distances between each city...")

edges = [
    (1, 2, 165),
    (1, 3, 148),
    (1, 4, 266),
    (1, 5, 190),
    (1, 6, 208),
    (2, 3, 75),
    (2, 4, 103),
    (2, 5, 192),
    (2, 6, 43),
    (3, 4, 142),
    (3, 5, 117),
    (3, 6, 109),
    (4, 5, 204),
    (4, 6, 70),
    (5, 6, 223)]

G=Graph(edges)
G.weighted(True)
G.relabel({
1:'ME' , 2:'MA', 3:'NH', 4:'CT', 5:'VT', 6:'RI'})
G.graphplot(edge_labels=True,save_pos=True).show()

print ("Kruskal's algorithm determines the following spanning tree of minimal distances:")

G.relabel({'ME':'Augusta' , 'MA':'Boston', 'NH':'Concord', 'CT':'Hartford', 'VT':'Montpelier', 'RI':'Providence'})
from sage.graphs.spanning_tree import kruskal
E = kruskal(G, check=True);E

T=Graph(E)
T.set_pos(G.get_pos())
T.graphplot(edge_labels=True).show()
︡8f656510-4340-4c2d-84a5-fdc2575ed81f︡{"stdout":"Homework 16 (2) 10.2 #2 : Use Kruskal's algorithm to find a minimal spanning tree for the capital cities of New England...\n"}︡{"stdout":"\n"}︡{"stdout":"ME: Augusta, Maine\n"}︡{"stdout":"MA: Boston, Massachusetts\n"}︡{"stdout":"NH: Concord, New Hampshire\n"}︡{"stdout":"CT: Hartford, Connecticut\n"}︡{"stdout":"VT: Montpelier, Vermont\n"}︡{"stdout":"RI: Providence, Rhode Island\n"}︡{"stdout":"\n"}︡{"stdout":"While not geographically true, the graph below does accurately depict the distances between each city...\n"}︡{"file":{"filename":"/home/user/.sage/temp/project-45969f91-2be6-4d3a-bba1-73d6881e6fc2/5076/tmp_JpKTAd.svg","show":true,"text":null,"uuid":"88e31443-1ab3-4ccc-91de-dd1bf5d457ba"},"once":false}︡{"stdout":"Kruskal's algorithm determines the following spanning tree of minimal distances:\n"}︡{"stdout":"[('Augusta', 'Concord', 148), ('Boston', 'Concord', 75), ('Boston', 'Providence', 43), ('Concord', 'Montpelier', 117), ('Hartford', 'Providence', 70)]\n"}︡{"file":{"filename":"/home/user/.sage/temp/project-45969f91-2be6-4d3a-bba1-73d6881e6fc2/5076/tmp_Du60Zt.svg","show":true,"text":null,"uuid":"2fc7761a-e4a4-416c-abe9-42c537195935"},"once":false}︡{"done":true}︡









